﻿using System;
using System.Configuration;
using System.IO;
using System.Web.Configuration;
using System.Xml;

namespace ConnectionKiller
{
    public class ConfigFileReader
    {
        public static string GetFirstConnectionstringFromConfigFile(string path)
        {
            var doc = new XmlDocument();
            doc.LoadXml(File.ReadAllText(path));
            var connectionStringsNode = doc.SelectNodes("//connectionStrings");
            if (connectionStringsNode != null && connectionStringsNode.Count != 0)
            {
                var connections = connectionStringsNode[0].ChildNodes;
                foreach (XmlNode c in connections)
                {
                    if (c is XmlComment)
                    {
                        continue;
                    }
                    return c.Attributes["connectionString"].Value;
                }

            }
            return "";
            
        }
    }
}
