﻿using System;
using System.Data.SqlClient;
using System.IO;

namespace ConnectionKiller
{
   
    class Program
    {
        static void Main(string[] args)
        {
            var configFile = GetConfigFileOrThrow();
            
            string connectionString = ConfigFileReader.GetFirstConnectionstringFromConfigFile(configFile);
            if (String.IsNullOrEmpty(connectionString))
            {
                throw new ArgumentException(string.Format("No connection string found in {0}",configFile));
            }

            var dbInfo = new SqlConnectionStringBuilder(connectionString);
            var databaseName = dbInfo.InitialCatalog;
            dbInfo.InitialCatalog = "Master";
            
            try
            {
                using (var conn = new SqlConnection(dbInfo.ConnectionString))
                {
                    conn.Open();
                    var commandText = "USE MASTER;" +
                                      "ALTER DATABASE " + databaseName + " SET SINGLE_USER WITH ROLLBACK IMMEDIATE;" +
                                      "ALTER DATABASE " + databaseName + " SET MULTI_USER;";
                    var cmd = conn.CreateCommand();
                    cmd.CommandText = commandText;
                    cmd.ExecuteNonQuery();
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Unable to execute sql.",ex);
            }
            
        }

        private static string GetConfigFileOrThrow()
        {
            if (File.Exists("App.Config"))
            {
                return "App.Config";
            }
            if (File.Exists("Web.Config"))
            {
                return "Web.Config";
            }
            throw new ArgumentException("No app.config or web.config found");
        }
    }
}
